<template>
  <q-page
    class="flex"
    v-if="cart"
    :class="{
      'content-start': cart && cart?.items?.length > 0,
      'content-center': cart && cart?.items?.length === 0,
    }"
  >
    <q-card flat class="full-width">
      <q-card-section
        v-if="cart.items && cart.items?.length == 0"
        class="flex flex-center"
      >
        <div
          class="text-h5 text-center text-primary"
          style="word-wrap: break-word"
        >
          {{ $t('PublicCart.NoItems') }}
        </div>
      </q-card-section>

      <q-card-section v-else>
        <q-list separator>
          <transition-group name="list-complete">
            <q-item
              clickable
              v-ripple
              v-for="item of items"
              :key="item.id"
              class="list-complete-item"
            >
              <q-item-section @click.prevent="toggleItem(item)">
                <q-item-label
                  :overline="false"
                  :caption="false"
                  :header="false"
                  lines="1"
                  :class="{
                    'text-strike': item.picked,
                    'light-dimmed': item.picked && !$q.dark.isActive,
                    dimmed: item.picked && $q.dark.isActive,
                  }"
                >
                  {{ item.name }}
                  <q-badge color="orange">{{ item.quantity_plan }} </q-badge>
                </q-item-label>
              </q-item-section>
              <q-item-section side>
                <q-btn
                  dense
                  round
                  color="red"
                  text-color="white"
                  icon="delete_outline"
                  @click.prevent="onShowDeleteDialog(item)"
                >
                </q-btn>
              </q-item-section>
              <q-item-section side>
                <q-btn
                  dense
                  round
                  color="teal"
                  text-color="white"
                  icon="edit"
                  @click.prevent="onShowEditDialog(item)"
                >
                </q-btn>
              </q-item-section>
            </q-item>
          </transition-group>
        </q-list>
      </q-card-section>
    </q-card>
    <q-dialog
      @before-hide="() => clearDialog()"
      v-model="showDeleteDialog"
      persistent
      @keyup.escape="showDeleteDialog = false"
      @keyup.enter.prevent.stop="deleteItem"
    >
      <q-card style="min-width: 75vw">
        <q-bar>
          {{ $t('PublicCart.remove') }}

          <q-space />
          <q-btn dense flat icon="close" v-close-popup />
        </q-bar>

        <q-card-section style="word-wrap: break-word">
          {{ $t('PublicCart.deleteMessage') }} {{ updatedItem.name }}?
        </q-card-section>

        <q-card-actions align="right">
          <q-btn
            outline
            rounded
            icon="delete"
            :label="$t('PublicCart.delete')"
            color="red"
            @click.prevent="deleteItem"
            v-close-popup
          />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <q-dialog
      v-model="showCreateDialog"
      @before-hide="() => clearDialog()"
      persistent
      @keyup.escape="showCreateDialog = false"
      @keyup.enter.prevent.stop="addItem"
    >
      <q-card style="min-width: 75vw">
        <q-bar>
          {{ $t('PublicCart.create') }}

          <q-space />
          <q-btn dense flat icon="close" v-close-popup />
        </q-bar>
        <q-card-section>
          <q-item>
            <q-item-section>
              <q-input
                v-model="itemName"
                type="text"
                :label="$t('PublicCart.name')"
                @keyup.enter.prevent.stop="addItem"
              >
              </q-input>
            </q-item-section>
            <q-item-section side>
              <q-input
                style="max-width: 90px"
                v-model="quantity_plan"
                type="number"
                :label="$t('PublicCart.quantity')"
                @keyup.enter.prevent.stop="addItem"
              />
            </q-item-section>
          </q-item>
        </q-card-section>
        <q-card-actions align="right">
          <q-btn
            @click="addItem"
            color="blue-grey"
            outline
            icon="add"
            rounded
            :label="$t('PublicCart.add')"
          ></q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>

    <q-dialog
      @before-hide="() => clearDialog()"
      v-model="showUpdateDialog"
      persistent
      @keyup.escape="showUpdateDialog = false"
      @keyup.enter.prevent.stop="editItem(updatedItem.id)"
    >
      <q-card style="min-width: 75vw">
        <q-bar>
          {{ $t('PublicCart.change') }}

          <q-space />
          <q-btn dense flat icon="close" v-close-popup />
        </q-bar>
        <q-card-section>
          <q-item>
            <q-item-section>
              <q-input
                v-model="updatedItem.name"
                type="text"
                :label="$t('PublicCart.name')"
                @keyup.enter.prevent.stop="editItem(updatedItem.id)"
              />
            </q-item-section>

            <q-item-section side>
              <q-input
                style="max-width: 90px"
                v-model="updatedItem.quantity_plan"
                type="number"
                :label="$t('PublicCart.quantity')"
                @keyup.enter.prevent.stop="editItem(updatedItem.id)"
              />
            </q-item-section>
          </q-item>
        </q-card-section>
        <q-card-actions align="right">
          <q-btn
            @click="editItem(updatedItem.id)"
            outline
            rounded
            color="teal"
            icon="save"
            :label="$t('PublicCart.save')"
          ></q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>

    <q-page-sticky position="bottom-right" :offset="[18, 18]">
      <div
        v-if="cart && cart.items && cart.items.length === 0"
        class="arrow-animation"
        :class="{
          'arrow-black': !$q.dark.isActive,
          'arrow-white': $q.dark.isActive,
        }"
      >
        <svg
          width="800"
          height="800"
          viewBox="0 0 24 24"
          fill="none"
          xmlns="http://www.w3.org/2000/svg"
        >
          <path
            d="M5 12h14m0 0-6-6m6 6-6 6"
            stroke-width="2"
            stroke-linecap="round"
            stroke-linejoin="round"
          />
        </svg>
      </div>
      <q-btn
        fab
        icon="add"
        color="accent"
        @click.prevent="showCreateDialog = true"
      />
    </q-page-sticky>
  </q-page>
</template>

<script lang="ts">
import { useCurrentUserStore } from '../stores/current-user';
import { useAllCartsStore } from 'src/stores/all-carts';

import { defineComponent } from 'vue';

import { mapActions, mapState } from 'pinia';
import { debugLog } from '../utils';
import { Cart, Item } from '../utils/IDBManager';

export default defineComponent({
  name: 'PublicCart',
  data() {
    return {
      itemName: null as string,
      quantity_plan: null as number,
      updatedItem: null as Item,
      showCreateDialog: false,
      showDeleteDialog: false,
      showUpdateDialog: false,
    };
  },

  methods: {
    ...mapActions(useAllCartsStore, {
      onAddItem: 'onAddItem',
      onDelItem: 'onDelItem',
      onEditItem: 'onEditItem',
      onToggleItem: 'onToggleItem',
    }),
    clearDialog() {
      this.itemName = null;
      this.quantity_plan = null;
      this.updatedItem = null;
    },

    addItem() {
      if (!this.itemName || this.itemName?.trim() === '') {
        this.$q.notify({
          message: `${this.$t('PublicCart.messages.msg15')}`,
          color: 'red',
        });
        return;
      }

      this.showCreateDialog = false;
      this.onAddItem(
        +this.$route.params.id,
        this.itemName.trim() || `${this.$t('PublicCart.messages.msg3')}`,
        this.quantity_plan || 1,
      )
        .then((resp) => {
          debugLog('responseAddItem', resp);

          this.$q.notify({
            message: `${this.$t('PublicCart.messages.msg4')}`,
            color: 'green',
          });
        })
        .catch((err) => {
          debugLog('errAddItem', err);
          this.$q.notify({
            message: `${this.$t('PublicCart.messages.msg5')} ${err}`,
            color: 'red-4',
            icon: 'warning',
          });
        });

      this.clearDialog();
    },
    toggleItem(item: Item) {
      this.onToggleItem(+this.$route.params.id, item.id, !item.picked)
        .then((resp: { picked: boolean }) => {
          this.$q.notify({
            message: `${this.$t('PublicCart.messages.msg6')} ${
              resp.picked
                ? this.$t('PublicCart.messages.msg7')
                : this.$t('PublicCart.messages.msg8')
            }`,
            color: 'blue',
          });
          debugLog('responseToggleItem', resp);
        })
        .catch((err) => {
          debugLog('errToggleItem', err);
          this.$q.notify({
            message: `${this.$t('PublicCart.messages.msg9')} ${err}`,
            color: 'red-4',
            icon: 'warning',
          });
        });
    },
    deleteItem() {
      this.showDeleteDialog = false;
      this.onDelItem(+this.$route.params.id, this.updatedItem.id)
        .then((resp) => {
          debugLog('responseDelItem', resp);
          this.$q.notify({
            message: `${this.$t('PublicCart.messages.msg10')}`,
            color: 'red',
          });
        })
        .catch((err) => {
          debugLog('errDelItem', err);
          this.$q.notify({
            message: `${this.$t('PublicCart.messages.msg11')} ${err}`,
            color: 'red-4',
            icon: 'warning',
          });
        });

      this.clearDialog();
    },
    editItem(updatedItem) {
      if (!this.updatedItem?.name || this.updatedItem?.name?.trim() === '') {
        this.$q.notify({
          message: `${this.$t('PublicCart.messages.msg15')}`,
          color: 'red',
        });
        this.showUpdateDialog = false;
        this.updatedItem.name = this.itemName;
        this.updatedItem.quantity_plan = this.quantity_plan;
        this.clearDialog();
        return;
      }

      if (
        this.updatedItem.name.trim() == this.itemName.trim() &&
        this.updatedItem.quantity_plan == this.quantity_plan
      ) {
        this.showUpdateDialog = false;
        this.updatedItem.name = this.itemName;
        this.clearDialog();

        return;
      }

      this.showUpdateDialog = false;

      this.onEditItem(+this.$route.params.id, this.updatedItem.id, {
        name:
          this.updatedItem.name.trim() ||
          `${this.$t('PublicCart.messages.msg12')}`,
        quantity_plan: this.updatedItem.quantity_plan || 1,
      })
        .then((resp) => {
          debugLog('responseEditItem', resp);
          this.$q.notify({
            message: `${this.$t('PublicCart.messages.msg13')}`,
            color: 'teal',
          });
        })
        .catch((err) => {
          debugLog('errEditItem', err);
          this.$q.notify({
            message: `${this.$t('PublicCart.messages.msg14')} ${err}`,
            color: 'red-4',
            icon: 'warning',
          });
        });

      this.clearDialog();
    },
    onShowDeleteDialog(item) {
      this.updatedItem = item;
      // Показать диалог удаления товара
      this.showDeleteDialog = true;
    },
    onShowEditDialog(item) {
      this.itemName = item.name;
      this.quantity_plan = item.quantity_plan;
      this.updatedItem = item;
      this.showUpdateDialog = true;
    },
  },
  watch: {
    cart: {
      handler(newVal) {
        if (newVal === null) {
          this.$router.push('/');
        }
      },
      // immediate: true,
    },
  },
  computed: {
    ...mapState(useCurrentUserStore, ['isLoggedIn']),

    ...mapState(useAllCartsStore, {
      cart(state): Cart | null {
        return state.getCart(+this.$route.params.id);
      },
    }),

    items(): Item[] {
      const no_picked: Item[] =
        this.cart?.items?.filter((item: Item) => {
          return item.picked === false;
        }) || [];
      const picked: Item[] =
        this.cart?.items?.filter((item: Item) => {
          return item.picked === true;
        }) || [];

      return this.cart?.items ? [...no_picked, ...picked] : [];
    },
  },
  mounted() {},
});
</script>
<style>
.list-complete-item {
  transition: all 0.5s;
}
.list-complete-enter, .list-complete-leave-to
/* .list-complete-leave-active до версии 2.1.8 */ {
  opacity: 0;
  transform: translateY(30px);
}
.list-complete-leave-active {
  position: absolute;
}
.arrow-animation {
  position: fixed;
  bottom: -24px;
  right: 50px;
  animation: arrow-bounce 2s infinite;
}
.arrow-white > svg {
  width: 120px;
  height: 90px;
  stroke: white;
}
.arrow-black > svg {
  width: 120px;
  height: 90px;
  stroke: black;
}

@keyframes arrow-bounce {
  0%,
  20%,
  50%,
  80%,
  100% {
    transform: translateX(0);
  }
  40% {
    transform: translateX(-30px);
  }
  60% {
    transform: translateX(-15px);
  }
}
</style>
